# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_xadcomputer`](#dsc_xadcomputer): The DSC xADComputer resource type. Automatically generated from version 3.0.0.0
* [`dsc_xaddomain`](#dsc_xaddomain): The DSC xADDomain resource type. Automatically generated from version 3.0.0.0
* [`dsc_xaddomaincontroller`](#dsc_xaddomaincontroller): The DSC xADDomainController resource type. Automatically generated from version 3.0.0.0
* [`dsc_xaddomaindefaultpasswordpolicy`](#dsc_xaddomaindefaultpasswordpolicy): The DSC xADDomainDefaultPasswordPolicy resource type. Automatically generated from version 3.0.0.0
* [`dsc_xaddomaintrust`](#dsc_xaddomaintrust): The DSC xADDomainTrust resource type. Automatically generated from version 3.0.0.0
* [`dsc_xadforestproperties`](#dsc_xadforestproperties): The DSC xADForestProperties resource type. Automatically generated from version 3.0.0.0
* [`dsc_xadgroup`](#dsc_xadgroup): The DSC xADGroup resource type. Automatically generated from version 3.0.0.0
* [`dsc_xadkdskey`](#dsc_xadkdskey): The DSC xADKDSKey resource type. Automatically generated from version 3.0.0.0
* [`dsc_xadmanagedserviceaccount`](#dsc_xadmanagedserviceaccount): The DSC xADManagedServiceAccount resource type. Automatically generated from version 3.0.0.0
* [`dsc_xadobjectenabledstate`](#dsc_xadobjectenabledstate): The DSC xADObjectEnabledState resource type. Automatically generated from version 3.0.0.0
* [`dsc_xadobjectpermissionentry`](#dsc_xadobjectpermissionentry): The DSC xADObjectPermissionEntry resource type. Automatically generated from version 3.0.0.0
* [`dsc_xadorganizationalunit`](#dsc_xadorganizationalunit): The DSC xADOrganizationalUnit resource type. Automatically generated from version 3.0.0.0
* [`dsc_xadrecyclebin`](#dsc_xadrecyclebin): The DSC xADRecycleBin resource type. Automatically generated from version 3.0.0.0
* [`dsc_xadreplicationsite`](#dsc_xadreplicationsite): The DSC xADReplicationSite resource type. Automatically generated from version 3.0.0.0
* [`dsc_xadreplicationsitelink`](#dsc_xadreplicationsitelink): The DSC xADReplicationSiteLink resource type. Automatically generated from version 3.0.0.0
* [`dsc_xadreplicationsubnet`](#dsc_xadreplicationsubnet): The DSC xADReplicationSubnet resource type. Automatically generated from version 3.0.0.0
* [`dsc_xadserviceprincipalname`](#dsc_xadserviceprincipalname): The DSC xADServicePrincipalName resource type. Automatically generated from version 3.0.0.0
* [`dsc_xaduser`](#dsc_xaduser): The DSC xADUser resource type. Automatically generated from version 3.0.0.0
* [`dsc_xwaitforaddomain`](#dsc_xwaitforaddomain): The DSC xWaitForADDomain resource type. Automatically generated from version 3.0.0.0

## Resource types

### <a name="dsc_xadcomputer"></a>`dsc_xadcomputer`

The DSC xADComputer resource type.
Automatically generated from version 3.0.0.0

#### Properties

The following properties are available in the `dsc_xadcomputer` type.

##### `dsc_description`

Data type: `Optional[String]`

Specifies a description of the computer account.

##### `dsc_displayname`

Data type: `Optional[String]`

Specifies the display name of the computer account.

##### `dsc_distinguishedname`

Data type: `Optional[String]`

Returns the X.500 path of the computer object

##### `dsc_dnshostname`

Data type: `Optional[String]`

Specifies the fully qualified domain name (FQDN) of the computer account.

##### `dsc_domaincontroller`

Data type: `Optional[String]`

Specifies the Active Directory Domain Services instance to connect to perform the task.

##### `dsc_enabled`

Data type: `Optional[Boolean]`

DEPRECATED - DO NOT USE. Please see the parameter EnabledOnCreation in this resource, and the resource xADObjectEnabledState on how to enforce the Enabled property. This parameter no longer sets or enforces the Enabled property. If this parameter is used then a warning message will be outputted saying that the Enabled parameter has been deprecated.

##### `dsc_enabledoncreation`

Data type: `Optional[Boolean]`

Specifies if the computer account is created enabled or disabled. By default the Enabled property of the computer account will be set to the default value of the cmdlet New-ADComputer. This property is ignored if the parameter RequestFile is specified in the same configuration. This parameter does not enforce the property Enabled. To enforce the property Enabled see the resource xADObjectEnabledState.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Specifies whether the computer account is present or absent. Valid values are 'Present' and 'Absent'. The default is 'Present'.

##### `dsc_location`

Data type: `Optional[String]`

Specifies the location of the computer, such as an office number.

##### `dsc_manager`

Data type: `Optional[String]`

Specifies the user or group Distinguished Name that manages the computer account. Valid values are the user's or group's DistinguishedName, ObjectGUID, SID or SamAccountName.

##### `dsc_path`

Data type: `Optional[String]`

Specifies the X.500 path of the Organizational Unit (OU) or container where the computer is located.

##### `dsc_requestfile`

Data type: `Optional[String]`

Specifies the full path to the Offline Domain Join Request file to create.

##### `dsc_restorefromrecyclebin`

Data type: `Optional[Boolean]`

Try to restore the computer account from the recycle bin before creating a new one.

##### `dsc_samaccountname`

Data type: `Optional[String]`

Returns the security identifier of the computer object

##### `dsc_serviceprincipalnames`

Data type: `Optional[Array[String]]`

Specifies the service principal names for the computer account.

##### `dsc_sid`

Data type: `Optional[String]`

Returns the security identifier of the computer object

##### `dsc_userprincipalname`

Data type: `Optional[String]`

Specifies the UPN assigned to the computer account.

#### Parameters

The following parameters are available in the `dsc_xadcomputer` type.

* [`dsc_computername`](#dsc_computername)
* [`dsc_domainadministratorcredential`](#dsc_domainadministratorcredential)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_computername"></a>`dsc_computername`

namevar

Data type: `String`

Specifies the name of the Active Directory computer account to manage. You can identify a computer by its distinguished
name, GUID, security identifier (SID) or Security Accounts Manager (SAM) account name.

##### <a name="dsc_domainadministratorcredential"></a>`dsc_domainadministratorcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Specifies the user account credentials to use to perform the task.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xaddomain"></a>`dsc_xaddomain`

The DSC xADDomain resource type.
Automatically generated from version 3.0.0.0

#### Properties

The following properties are available in the `dsc_xaddomain` type.

##### `dsc_databasepath`

Data type: `Optional[String]`

Path to a directory that contains the domain database

##### `dsc_domainmode`

Data type: `Optional[Enum['Win2008', 'Win2008R2', 'Win2012', 'Win2012R2', 'WinThreshold']]`

The Domain Functional Level for the entire domain

##### `dsc_domainnetbiosname`

Data type: `Optional[String]`

NetBIOS name for the new domain

##### `dsc_forestmode`

Data type: `Optional[Enum['Win2008', 'Win2008R2', 'Win2012', 'Win2012R2', 'WinThreshold']]`

The Forest Functional Level for the entire forest

##### `dsc_logpath`

Data type: `Optional[String]`

Path to a directory for the log file that will be written

##### `dsc_parentdomainname`

Data type: `Optional[String]`

Fully qualified name of the parent domain

##### `dsc_sysvolpath`

Data type: `Optional[String]`

Path to a directory where the Sysvol file will be written

#### Parameters

The following parameters are available in the `dsc_xaddomain` type.

* [`dsc_dnsdelegationcredential`](#dsc_dnsdelegationcredential)
* [`dsc_domainadministratorcredential`](#dsc_domainadministratorcredential)
* [`dsc_domainname`](#dsc_domainname)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_safemodeadministratorpassword`](#dsc_safemodeadministratorpassword)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_dnsdelegationcredential"></a>`dsc_dnsdelegationcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credential used for creating DNS delegation

##### <a name="dsc_domainadministratorcredential"></a>`dsc_domainadministratorcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credentials used to query for domain existence

##### <a name="dsc_domainname"></a>`dsc_domainname`

namevar

Data type: `String`

FQDN of the new domain

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_safemodeadministratorpassword"></a>`dsc_safemodeadministratorpassword`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Password for the administrator account when the computer is started in Safe Mode

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xaddomaincontroller"></a>`dsc_xaddomaincontroller`

The DSC xADDomainController resource type.
Automatically generated from version 3.0.0.0

#### Properties

The following properties are available in the `dsc_xaddomaincontroller` type.

##### `dsc_databasepath`

Data type: `Optional[String]`

The path where the database will be stored.

##### `dsc_ensure`

Data type: `Optional[String]`

The state of the Domain Controller.

##### `dsc_installationmediapath`

Data type: `Optional[String]`

The path of the media you want to use install the Domain Controller.

##### `dsc_isglobalcatalog`

Data type: `Optional[Boolean]`

Specifies if the domain controller will be a Global Catalog (GC).

##### `dsc_logpath`

Data type: `Optional[String]`

The path where the logs will be stored.

##### `dsc_sitename`

Data type: `Optional[String]`

The name of the site this Domain Controller will be added to.

##### `dsc_sysvolpath`

Data type: `Optional[String]`

The path where the Sysvol will be stored.

#### Parameters

The following parameters are available in the `dsc_xaddomaincontroller` type.

* [`dsc_domainadministratorcredential`](#dsc_domainadministratorcredential)
* [`dsc_domainname`](#dsc_domainname)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_safemodeadministratorpassword`](#dsc_safemodeadministratorpassword)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_domainadministratorcredential"></a>`dsc_domainadministratorcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

The 'PSCredential' object containing Domain Administrator rights to add the Domain Controller to the domain.

##### <a name="dsc_domainname"></a>`dsc_domainname`

namevar

Data type: `String`

The FQDN of the domain the Domain Controller will be joining.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_safemodeadministratorpassword"></a>`dsc_safemodeadministratorpassword`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

The 'PSCredential' object containing the password to use for DSRM.

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xaddomaindefaultpasswordpolicy"></a>`dsc_xaddomaindefaultpasswordpolicy`

The DSC xADDomainDefaultPasswordPolicy resource type.
Automatically generated from version 3.0.0.0

#### Properties

The following properties are available in the `dsc_xaddomaindefaultpasswordpolicy` type.

##### `dsc_complexityenabled`

Data type: `Optional[Boolean]`

Whether password complexity is enabled for the default password policy

##### `dsc_domaincontroller`

Data type: `Optional[String]`

Active Directory domain controller to enact the change upon

##### `dsc_lockoutduration`

Data type: `Optional[Integer[0, 4294967295]]`

Length of time that an account is locked after the number of failed login attempts (minutes)

##### `dsc_lockoutobservationwindow`

Data type: `Optional[Integer[0, 4294967295]]`

Maximum time between two unsuccessful login attempts before the counter is reset to 0 (minutes)

##### `dsc_lockoutthreshold`

Data type: `Optional[Integer[0, 4294967295]]`

Number of unsuccessful login attempts that are permitted before an account is locked out

##### `dsc_maxpasswordage`

Data type: `Optional[Integer[0, 4294967295]]`

Maximum length of time that you can have the same password (minutes)

##### `dsc_minpasswordage`

Data type: `Optional[Integer[0, 4294967295]]`

Minimum length of time that you can have the same password (minutes)

##### `dsc_minpasswordlength`

Data type: `Optional[Integer[0, 4294967295]]`

Minimum number of characters that a password must contain

##### `dsc_passwordhistorycount`

Data type: `Optional[Integer[0, 4294967295]]`

Number of previous passwords to remember

##### `dsc_reversibleencryptionenabled`

Data type: `Optional[Boolean]`

Whether the directory must store passwords using reversible encryption

#### Parameters

The following parameters are available in the `dsc_xaddomaindefaultpasswordpolicy` type.

* [`dsc_credential`](#dsc_credential)
* [`dsc_domainname`](#dsc_domainname)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_credential"></a>`dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credentials used to access the domain

##### <a name="dsc_domainname"></a>`dsc_domainname`

namevar

Data type: `String`

Name of the domain to which the password policy will be applied

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xaddomaintrust"></a>`dsc_xaddomaintrust`

The DSC xADDomainTrust resource type.
Automatically generated from version 3.0.0.0

#### Properties

The following properties are available in the `dsc_xaddomaintrust` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Should this resource be present or absent

##### `dsc_trustdirection`

Data type: `Enum['Bidirectional', 'Inbound', 'Outbound']`

Direction of trust

##### `dsc_trusttype`

Data type: `Enum['External', 'Forest']`

Type of trust

#### Parameters

The following parameters are available in the `dsc_xaddomaintrust` type.

* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_sourcedomainname`](#dsc_sourcedomainname)
* [`dsc_targetdomainadministratorcredential`](#dsc_targetdomainadministratorcredential)
* [`dsc_targetdomainname`](#dsc_targetdomainname)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_sourcedomainname"></a>`dsc_sourcedomainname`

namevar

Data type: `String`

Name of the AD domain that is requesting the trust

##### <a name="dsc_targetdomainadministratorcredential"></a>`dsc_targetdomainadministratorcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credentials to authenticate to the target domain

##### <a name="dsc_targetdomainname"></a>`dsc_targetdomainname`

namevar

Data type: `String`

Name of the AD domain that is being trusted

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xadforestproperties"></a>`dsc_xadforestproperties`

The DSC xADForestProperties resource type.
Automatically generated from version 3.0.0.0

#### Properties

The following properties are available in the `dsc_xadforestproperties` type.

##### `dsc_serviceprincipalnamesuffix`

Data type: `Optional[Array[String]]`

Specifies the Service Principal Name (SPN) Suffix(es) to be explicitly defined in the forest and replace existing SPNs. Cannot be used with ServicePrincipalNameSuffixToAdd or ServicePrincipalNameSuffixToRemove.

##### `dsc_serviceprincipalnamesuffixtoadd`

Data type: `Optional[Array[String]]`

Specifies the Service Principal Name (SPN) Suffix(es) to be added to the forest. Cannot be used with ServicePrincipalNameSuffix.

##### `dsc_serviceprincipalnamesuffixtoremove`

Data type: `Optional[Array[String]]`

Specifies the Service Principal Name (SPN) Suffix(es) to be removed from the forest. Cannot be used with ServicePrincipalNameSuffix.

##### `dsc_userprincipalnamesuffix`

Data type: `Optional[Array[String]]`

Specifies the User Principal Name (UPN) Suffix(es) to be explicitly defined in the forest and replace existing UPNs. Cannot be used with UserPrincipalNameSuffixToAdd or UserPrincipalNameSuffixToRemove.

##### `dsc_userprincipalnamesuffixtoadd`

Data type: `Optional[Array[String]]`

Specifies the User Principal Name (UPN) Suffix(es) to be added to the forest. Cannot be used with UserPrincipalNameSuffix.

##### `dsc_userprincipalnamesuffixtoremove`

Data type: `Optional[Array[String]]`

Specifies the User Principal Name (UPN) Suffix(es) to be removed from the forest. Cannot be used with UserPrincipalNameSuffix.

#### Parameters

The following parameters are available in the `dsc_xadforestproperties` type.

* [`dsc_credential`](#dsc_credential)
* [`dsc_forestname`](#dsc_forestname)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_credential"></a>`dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Specifies the user account credentials to use to perform this task.

##### <a name="dsc_forestname"></a>`dsc_forestname`

namevar

Data type: `String`

Specifies the target Active Directory forest for the change.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xadgroup"></a>`dsc_xadgroup`

The DSC xADGroup resource type.
Automatically generated from version 3.0.0.0

#### Properties

The following properties are available in the `dsc_xadgroup` type.

##### `dsc_category`

Data type: `Optional[Enum['Security', 'Distribution']]`

Active Directory group category

##### `dsc_description`

Data type: `Optional[String]`

Description of the Active Directory group

##### `dsc_displayname`

Data type: `Optional[String]`

Display name of the Active Directory group

##### `dsc_domaincontroller`

Data type: `Optional[String]`

Active Directory domain controller to enact the change upon

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Should this resource be present or absent

##### `dsc_groupscope`

Data type: `Optional[Enum['DomainLocal', 'Global', 'Universal']]`

Active Directory group scope

##### `dsc_managedby`

Data type: `Optional[String]`

Active Directory managed by attribute specified as a DistinguishedName

##### `dsc_members`

Data type: `Optional[Array[String]]`

Active Directory group membership should match membership exactly

##### `dsc_membershipattribute`

Data type: `Optional[Enum['SamAccountName', 'DistinguishedName', 'ObjectGUID', 'SID']]`

Active Directory attribute used to perform membership operations

##### `dsc_memberstoexclude`

Data type: `Optional[Array[String]]`

Active Directory group should NOT include these members

##### `dsc_memberstoinclude`

Data type: `Optional[Array[String]]`

Active Directory group should include these members

##### `dsc_notes`

Data type: `Optional[String]`

Active Directory group notes field

##### `dsc_path`

Data type: `Optional[String]`

Location of the group within Active Directory expressed as a Distinguished Name

##### `dsc_restorefromrecyclebin`

Data type: `Optional[Boolean]`

Try to restore the group from the recycle bin before creating a new one.

#### Parameters

The following parameters are available in the `dsc_xadgroup` type.

* [`dsc_credential`](#dsc_credential)
* [`dsc_groupname`](#dsc_groupname)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_credential"></a>`dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credentials used to enact the change upon

##### <a name="dsc_groupname"></a>`dsc_groupname`

namevar

Data type: `String`

Name of the Active Directory group

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xadkdskey"></a>`dsc_xadkdskey`

The DSC xADKDSKey resource type.
Automatically generated from version 3.0.0.0

#### Properties

The following properties are available in the `dsc_xadkdskey` type.

##### `dsc_allowunsafeeffectivetime`

Data type: `Optional[Boolean]`

This option will allow you to create a KDS root key if EffectiveTime is set in the past. This may cause issues if you are creating a Group Managed Service Account right after you create the KDS Root Key. In order to get around this, you must create the KDS Root Key using a date in the past. This should be used at your own risk and should only be used in lab environments.

##### `dsc_creationtime`

Data type: `Optional[Timestamp]`

Specifies the Creation date and time of the KDS root key for informational purposes

##### `dsc_distinguishedname`

Data type: `Optional[String]`

Specifies the Distinguished Name (DN) of the KDS root key. The KDS Root Key is stored in 'CN=Master Root Keys,CN=Group Key Distribution Service,CN=Services,CN=Configuration' at the Forest level. This is also why replication needs 10 hours to occur before using the KDS Root Key as a safey measure.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Specifies if this KDS Root Key should be present or absent

##### `dsc_forceremove`

Data type: `Optional[Boolean]`

This option will allow you to remove a KDS root key if there is only one key left. It should not break your Group Managed Service Accounts (gMSAs), but if the gMSA password expires and it needs to request a new password, it will not be able to generate a new password until a new KDS Root Key is installed and ready for use. Because of this, the last KDS Root Key will not be removed unless this option is specified

##### `dsc_keyid`

Data type: `Optional[String]`

Specifies the KeyID of the KDS root key. This is the Common Name (CN) within Active Directory and is required to build the Distinguished Name

#### Parameters

The following parameters are available in the `dsc_xadkdskey` type.

* [`dsc_effectivetime`](#dsc_effectivetime)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_effectivetime"></a>`dsc_effectivetime`

namevar

Data type: `String`

Specifies the Effective time when a KDS root key can be used. There is a 10 hour minimum from creation date to allow
active directory to properly replicate across all domain controllers. For this reason, the date must be set in the
future for creation. While this parameter accepts a string, it will be converted into a DateTime object. This will also
try to take into account cultural settings. Example: '05/01/1999 13:00 using default or 'en-US' culture would be May
1st, but using 'de-DE' culture would be 5th of January. The culture is automatically pulled from the operating system
and this can be checked using 'Get-Culture'

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xadmanagedserviceaccount"></a>`dsc_xadmanagedserviceaccount`

The DSC xADManagedServiceAccount resource type.
Automatically generated from version 3.0.0.0

#### Properties

The following properties are available in the `dsc_xadmanagedserviceaccount` type.

##### `dsc_accounttype`

Data type: `Optional[Enum['Group', 'Single']]`

The type of managed service account. Single will create a Single Managed Service Account (sMSA) and Group will create a Group Managed Service Account (gMSA). If not specified, this vaule defaults to Single.

##### `dsc_accounttypeforce`

Data type: `Optional[Boolean]`

Specifies whether or not to remove the service account and recreate it when going from single MSA to group MSA and vice-versa. If not specified, this value defaults to False.

##### `dsc_description`

Data type: `Optional[String]`

Specifies a description of the object (ldapDisplayName 'description')

##### `dsc_displayname`

Data type: `Optional[String]`

Specifies the display name of the object (ldapDisplayName 'displayName')

##### `dsc_distinguishedname`

Data type: `Optional[String]`

Specifies the Distinguished Name of the Service Account. Cannot be specified in the resource. Returned by Get and Compare.

##### `dsc_domaincontroller`

Data type: `Optional[String]`

Specifies the Active Directory Domain Controller instance to use to perform the task. This is only required if not executing the task on a domain controller.

##### `dsc_enabled`

Data type: `Optional[Boolean]`

Specifies whether the user account is enabled or disabled.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Specifies whether the user account is created or deleted. If not specified, this value defaults to Present.

##### `dsc_members`

Data type: `Optional[Array[String]]`

Specifies the members of the object (ldapDisplayName 'PrincipalsAllowedToRetrieveManagedPassword'). Only used when 'Group' is selected for 'AccountType'

##### `dsc_membershipattribute`

Data type: `Optional[Enum['SamAccountName', 'DistinguishedName', 'ObjectGUID', 'SID']]`

Active Directory attribute used to perform membership operations for Group Managed Service Accounts (gMSAs). If not specified, this value defaults to SamAccountName. Only used when 'Group' is selected for 'AccountType'

##### `dsc_path`

Data type: `Optional[String]`

Specifies the X.500 path of the Organizational Unit (OU) or container where the new object is created. Specified as a Distinguished Name (DN).

#### Parameters

The following parameters are available in the `dsc_xadmanagedserviceaccount` type.

* [`dsc_credential`](#dsc_credential)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_serviceaccountname`](#dsc_serviceaccountname)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_credential"></a>`dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Specifies the user account credentials to use to perform this task. This is only required if not executing the task on a
domain controller or using the -DomainController parameter.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_serviceaccountname"></a>`dsc_serviceaccountname`

namevar

Data type: `String`

Specifies the Security Account Manager (SAM) account name of the managed service account (ldapDisplayName
'sAMAccountName'). To be compatible with older operating systems, create a SAM account name that is 20 characters or
less. Once created, the user's SamAccountName and CN cannot be changed.

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xadobjectenabledstate"></a>`dsc_xadobjectenabledstate`

The DSC xADObjectEnabledState resource type.
Automatically generated from version 3.0.0.0

#### Properties

The following properties are available in the `dsc_xadobjectenabledstate` type.

##### `dsc_domaincontroller`

Data type: `Optional[String]`

Specifies the Active Directory Domain Services instance to connect to perform the task.

##### `dsc_enabled`

Data type: `Boolean`

Specifies the value of the Enabled property.

#### Parameters

The following parameters are available in the `dsc_xadobjectenabledstate` type.

* [`dsc_credential`](#dsc_credential)
* [`dsc_identity`](#dsc_identity)
* [`dsc_objectclass`](#dsc_objectclass)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_credential"></a>`dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Specifies the user account credentials to use to perform the task.

##### <a name="dsc_identity"></a>`dsc_identity`

namevar

Data type: `String`

Specifies the identity of an object that has the object class specified in the parameter ObjectClass. When ObjectClass
is set to 'Computer' then this property can be set to either distinguished name, GUID (objectGUID), security identifier
(objectSid), or security Accounts Manager account name (sAMAccountName).

##### <a name="dsc_objectclass"></a>`dsc_objectclass`

namevar

Data type: `Enum['Computer']`

Specifies the object class.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xadobjectpermissionentry"></a>`dsc_xadobjectpermissionentry`

The DSC xADObjectPermissionEntry resource type.
Automatically generated from version 3.0.0.0

#### Properties

The following properties are available in the `dsc_xadobjectpermissionentry` type.

##### `dsc_activedirectoryrights`

Data type: `Optional[Array[Enum['AccessSystemSecurity', 'CreateChild', 'Delete', 'DeleteChild', 'DeleteTree', 'ExtendedRight', 'GenericAll', 'GenericExecute', 'GenericRead', 'GenericWrite', 'ListChildren', 'ListObject', 'ReadControl', 'ReadProperty', 'Self', 'Synchronize', 'WriteDacl', 'WriteOwner', 'WriteProperty']]]`

A combination of one or more of the ActiveDirectoryRights enumeration values that specifies the rights of the access rule. Default is 'GenericAll'.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Indicates if the access will be added (Present) or will be removed (Absent). Default is 'Present'.

#### Parameters

The following parameters are available in the `dsc_xadobjectpermissionentry` type.

* [`dsc_accesscontroltype`](#dsc_accesscontroltype)
* [`dsc_activedirectorysecurityinheritance`](#dsc_activedirectorysecurityinheritance)
* [`dsc_identityreference`](#dsc_identityreference)
* [`dsc_inheritedobjecttype`](#dsc_inheritedobjecttype)
* [`dsc_objecttype`](#dsc_objecttype)
* [`dsc_path`](#dsc_path)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_accesscontroltype"></a>`dsc_accesscontroltype`

namevar

Data type: `Enum['Allow', 'Deny']`

Indicates whether to Allow or Deny access to the target object.

##### <a name="dsc_activedirectorysecurityinheritance"></a>`dsc_activedirectorysecurityinheritance`

namevar

Data type: `Enum['All', 'Children', 'Descendents', 'None', 'SelfAndChildren']`

One of the 'ActiveDirectorySecurityInheritance' enumeration values that specifies the inheritance type of the access
rule.

##### <a name="dsc_identityreference"></a>`dsc_identityreference`

namevar

Data type: `String`

Indicates the identity of the principal for the ACE. Use the notation DOMAIN\SamAccountName for the identity.

##### <a name="dsc_inheritedobjecttype"></a>`dsc_inheritedobjecttype`

namevar

Data type: `String`

The schema GUID of the child object type that can inherit this access rule. If the permission entry shouldn't be
restricted to a specific inherited object type, use the zero guid: 00000000-0000-0000-0000-000000000000.

##### <a name="dsc_objecttype"></a>`dsc_objecttype`

namevar

Data type: `String`

The schema GUID of the object to which the access rule applies. If the permission entry shouldn't be restricted to a
specific object type, use the zero guid: 00000000-0000-0000-0000-000000000000.

##### <a name="dsc_path"></a>`dsc_path`

namevar

Data type: `String`

Active Directory path of the target object to add or remove the permission entry, specified as a Distinguished Name.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xadorganizationalunit"></a>`dsc_xadorganizationalunit`

The DSC xADOrganizationalUnit resource type.
Automatically generated from version 3.0.0.0

#### Properties

The following properties are available in the `dsc_xadorganizationalunit` type.

##### `dsc_description`

Data type: `Optional[String]`

The description of the OU

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

 

##### `dsc_protectedfromaccidentaldeletion`

Data type: `Optional[Boolean]`

Defaults to True

##### `dsc_restorefromrecyclebin`

Data type: `Optional[Boolean]`

Try to restore the organizational unit from the recycle bin before creating a new one.

#### Parameters

The following parameters are available in the `dsc_xadorganizationalunit` type.

* [`dsc_credential`](#dsc_credential)
* [`dsc_name`](#dsc_name)
* [`dsc_path`](#dsc_path)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_credential"></a>`dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

The credential to be used to perform the operation on Active Directory

##### <a name="dsc_name"></a>`dsc_name`

namevar

Data type: `String`

The name of OU

##### <a name="dsc_path"></a>`dsc_path`

namevar

Data type: `String`

Specifies the X500 path of the OU or container where the new object is created

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xadrecyclebin"></a>`dsc_xadrecyclebin`

The DSC xADRecycleBin resource type.
Automatically generated from version 3.0.0.0

#### Properties

The following properties are available in the `dsc_xadrecyclebin` type.

##### `dsc_forestmode`

Data type: `Optional[String]`

The functional level of the forest.

##### `dsc_recyclebinenabled`

Data type: `Optional[String]`

The state of the Recycle Bin feature.

#### Parameters

The following parameters are available in the `dsc_xadrecyclebin` type.

* [`dsc_enterpriseadministratorcredential`](#dsc_enterpriseadministratorcredential)
* [`dsc_forestfqdn`](#dsc_forestfqdn)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_enterpriseadministratorcredential"></a>`dsc_enterpriseadministratorcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

The user account credentials to use to perform this task.

##### <a name="dsc_forestfqdn"></a>`dsc_forestfqdn`

namevar

Data type: `String`

The FQDN of the forest in which to change the Recycle Bin feature.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xadreplicationsite"></a>`dsc_xadreplicationsite`

The DSC xADReplicationSite resource type.
Automatically generated from version 3.0.0.0

#### Properties

The following properties are available in the `dsc_xadreplicationsite` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Specifies if the AD replication site should be added or remove. Default value is 'Present'. { *Present* | Absent }.

##### `dsc_renamedefaultfirstsitename`

Data type: `Optional[Boolean]`

Specify if the Default-First-Site-Name should be renamed, if it exists. Dafult value is 'false'.

#### Parameters

The following parameters are available in the `dsc_xadreplicationsite` type.

* [`dsc_name`](#dsc_name)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_name"></a>`dsc_name`

namevar

Data type: `String`

Specifies the name of the AD replication site.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xadreplicationsitelink"></a>`dsc_xadreplicationsitelink`

The DSC xADReplicationSiteLink resource type.
Automatically generated from version 3.0.0.0

#### Properties

The following properties are available in the `dsc_xadreplicationsitelink` type.

##### `dsc_cost`

Data type: `Optional[Integer[-2147483648, 2147483647]]`

Specifies the cost to be placed on the site link

##### `dsc_description`

Data type: `Optional[String]`

This parameter sets the value of the Description property for the object

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Specifies if the site link is created or deleted

##### `dsc_replicationfrequencyinminutes`

Data type: `Optional[Integer[-2147483648, 2147483647]]`

Species the frequency (in minutes) for which replication will occur where this site link is in use between sites

##### `dsc_sitesexcluded`

Data type: `Optional[Array[String]]`

Specifies the list of sites to exclude from the site link

##### `dsc_sitesincluded`

Data type: `Optional[Array[String]]`

Specifies the list of sites included in the site link

#### Parameters

The following parameters are available in the `dsc_xadreplicationsitelink` type.

* [`dsc_name`](#dsc_name)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_name"></a>`dsc_name`

namevar

Data type: `String`

Specifies the name of the site link

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xadreplicationsubnet"></a>`dsc_xadreplicationsubnet`

The DSC xADReplicationSubnet resource type.
Automatically generated from version 3.0.0.0

#### Properties

The following properties are available in the `dsc_xadreplicationsubnet` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Specifies if the AD replication subnet should be added or remove. Default value is 'Present'.

##### `dsc_location`

Data type: `Optional[String]`

The location for the AD replication site. Default value is empty.

##### `dsc_site`

Data type: `String`

The name of the assigned AD replication site, e.g. Default-First-Site-Name.

#### Parameters

The following parameters are available in the `dsc_xadreplicationsubnet` type.

* [`dsc_name`](#dsc_name)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_name"></a>`dsc_name`

namevar

Data type: `String`

The name of the AD replication subnet, e.g. 10.0.0.0/24.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xadserviceprincipalname"></a>`dsc_xadserviceprincipalname`

The DSC xADServicePrincipalName resource type.
Automatically generated from version 3.0.0.0

#### Properties

The following properties are available in the `dsc_xadserviceprincipalname` type.

##### `dsc_account`

Data type: `Optional[String]`

The user or computer account to add or remove the SPN, e.b. User1 or LON-DC1$. Default value is ''. If Ensure is set to Present, a value must be specified.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Specifies if the service principal name should be added or remove. Default value is 'Present'.

#### Parameters

The following parameters are available in the `dsc_xadserviceprincipalname` type.

* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_serviceprincipalname`](#dsc_serviceprincipalname)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_serviceprincipalname"></a>`dsc_serviceprincipalname`

namevar

Data type: `String`

The full SPN to add or remove, e.g. HOST/LON-DC1.

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xaduser"></a>`dsc_xaduser`

The DSC xADUser resource type.
Automatically generated from version 3.0.0.0

#### Properties

The following properties are available in the `dsc_xaduser` type.

##### `dsc_accountnotdelegated`

Data type: `Optional[Boolean]`

Indicates whether the security context of the user is delegated to a service.  When this parameter is set to true, the security context of the account is not delegated to a service even when the service account is set as trusted for Kerberos delegation. This parameter sets the AccountNotDelegated property for an Active Directory account. This parameter also sets the ADS_UF_NOT_DELEGATED flag of the Active Directory User Account Control (UAC) attribute.

##### `dsc_allowreversiblepasswordencryption`

Data type: `Optional[Boolean]`

Indicates whether reversible password encryption is allowed for the account. This parameter sets the AllowReversiblePasswordEncryption property of the account. This parameter also sets the ADS_UF_ENCRYPTED_TEXT_PASSWORD_ALLOWED flag of the Active Directory User Account Control (UAC) attribute.

##### `dsc_cannotchangepassword`

Data type: `Optional[Boolean]`

Specifies whether the account password can be changed

##### `dsc_changepasswordatlogon`

Data type: `Optional[Boolean]`

Specifies whether the account password must be changed during the next logon attempt. This cannot be set to true if the PasswordNeverExpires property is also set to true

##### `dsc_city`

Data type: `Optional[String]`

Specifies the user's town or city (ldapDisplayName 'l')

##### `dsc_commonname`

Data type: `Optional[String]`

Specifies the common nane assigned to the user account (ldapDisplayName 'cn')

##### `dsc_company`

Data type: `Optional[String]`

Specifies the user's company (ldapDisplayName 'company')

##### `dsc_compoundidentitysupported`

Data type: `Optional[Boolean]`

Specifies whether an account supports Kerberos service tickets which includes the authorization data for the user's device. This value sets the compound identity supported flag of the Active Directory msDS-SupportedEncryptionTypes attribute.

##### `dsc_country`

Data type: `Optional[String]`

Specifies the country or region code for the user's language of choice (ldapDisplayName 'c')

##### `dsc_department`

Data type: `Optional[String]`

Specifies the user's department (ldapDisplayName 'department')

##### `dsc_description`

Data type: `Optional[String]`

Specifies a description of the object (ldapDisplayName 'description')

##### `dsc_displayname`

Data type: `Optional[String]`

Specifies the display name of the object (ldapDisplayName 'displayName')

##### `dsc_distinguishedname`

Data type: `Optional[String]`

Returns the X.500 path of the object

##### `dsc_division`

Data type: `Optional[String]`

Specifies the user's division (ldapDisplayName 'division')

##### `dsc_domaincontroller`

Data type: `Optional[String]`

Specifies the Active Directory Domain Services instance to use to perform the task.

##### `dsc_emailaddress`

Data type: `Optional[String]`

Specifies the user's e-mail address (ldapDisplayName 'mail')

##### `dsc_employeeid`

Data type: `Optional[String]`

Specifies the user's employee ID (ldapDisplayName 'employeeID')

##### `dsc_employeenumber`

Data type: `Optional[String]`

Specifies the user's employee number (ldapDisplayName 'employeeNumber')

##### `dsc_enabled`

Data type: `Optional[Boolean]`

Specifies if the account is enabled (default True)

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Specifies whether the user account is created or deleted

##### `dsc_fax`

Data type: `Optional[String]`

Specifies the user's fax phone number (ldapDisplayName 'facsimileTelephoneNumber')

##### `dsc_givenname`

Data type: `Optional[String]`

Specifies the user's given name (ldapDisplayName 'givenName')

##### `dsc_homedirectory`

Data type: `Optional[String]`

Specifies a user's home directory path (ldapDisplayName 'homeDirectory')

##### `dsc_homedrive`

Data type: `Optional[String]`

Specifies a drive that is associated with the UNC path defined by the HomeDirectory property (ldapDisplayName 'homeDrive')

##### `dsc_homepage`

Data type: `Optional[String]`

Specifies the URL of the home page of the object (ldapDisplayName 'wWWHomePage')

##### `dsc_homephone`

Data type: `Optional[String]`

Specifies the user's home telephone number (ldapDisplayName 'homePhone')

##### `dsc_initials`

Data type: `Optional[String]`

Specifies the initials that represent part of a user's name (ldapDisplayName 'initials')

##### `dsc_ipphone`

Data type: `Optional[String]`

Specifies the user's IP telephony phone number (ldapDisplayName 'ipPhone')

##### `dsc_jobtitle`

Data type: `Optional[String]`

Specifies the user's title (ldapDisplayName 'title')

##### `dsc_logonscript`

Data type: `Optional[String]`

Specifies a path to the user's log on script (ldapDisplayName 'scriptPath')

##### `dsc_logonworkstations`

Data type: `Optional[String]`

Specifies the computers that the user can access. To specify more than one computer, create a single comma-separated list. You can identify a computer by using the Security Account Manager (SAM) account name (sAMAccountName) or the DNS host name of the computer. The SAM account name is the same as the NetBIOS name of the computer. The LDAP display name (ldapDisplayName) for this property is userWorkStations.

##### `dsc_manager`

Data type: `Optional[String]`

Specifies the user's manager specified as a Distinguished Name (ldapDisplayName 'manager')

##### `dsc_mobilephone`

Data type: `Optional[String]`

Specifies the user's mobile phone number (ldapDisplayName 'mobile')

##### `dsc_notes`

Data type: `Optional[String]`

Specifies the notes attached to the user's accoutn (ldapDisplayName 'info')

##### `dsc_office`

Data type: `Optional[String]`

Specifies the location of the user's office or place of business (ldapDisplayName 'physicalDeliveryOfficeName')

##### `dsc_officephone`

Data type: `Optional[String]`

Specifies the user's office telephone number (ldapDisplayName 'telephoneNumber')

##### `dsc_organization`

Data type: `Optional[String]`

Specifies the user's organization. This parameter sets the Organization property of a user object. The LDAP display name (ldapDisplayName) of this property is o.

##### `dsc_othername`

Data type: `Optional[String]`

Specifies a name in addition to a user's given name and surname, such as the user's middle name. This parameter sets the OtherName property of a user object. The LDAP display name (ldapDisplayName) of this property is middleName.

##### `dsc_pager`

Data type: `Optional[String]`

Specifies the user's pager number (ldapDisplayName 'pager')

##### `dsc_passwordauthentication`

Data type: `Optional[Enum['Default', 'Negotiate']]`

Specifies the authentication context type used when testing passwords

##### `dsc_passwordneverexpires`

Data type: `Optional[Boolean]`

Specifies whether the password of an account can expire

##### `dsc_passwordneverresets`

Data type: `Optional[Boolean]`

Specifies whether existing user's password should be reset (default $false)

##### `dsc_passwordnotrequired`

Data type: `Optional[Boolean]`

Specifies whether the account requires a password. A password is not required for a new account. This parameter sets the PasswordNotRequired property of an account object.

##### `dsc_path`

Data type: `Optional[String]`

Specifies the X.500 path of the Organizational Unit (OU) or container where the new object is created

##### `dsc_pobox`

Data type: `Optional[String]`

Specifies the user's post office box number (ldapDisplayName 'postOfficeBox')

##### `dsc_postalcode`

Data type: `Optional[String]`

Specifies the user's postal code or zip code (ldapDisplayName 'postalCode')

##### `dsc_profilepath`

Data type: `Optional[String]`

Specifies a path to the user's profile (ldapDisplayName 'profilePath')

##### `dsc_proxyaddresses`

Data type: `Optional[Array[String]]`

Specifies the proxy addresses for the user account.

##### `dsc_restorefromrecyclebin`

Data type: `Optional[Boolean]`

Try to restore the user object from the recycle bin before creating a new one.

##### `dsc_serviceprincipalnames`

Data type: `Optional[Array[String]]`

Specifies the service principal names for the user account.

##### `dsc_smartcardlogonrequired`

Data type: `Optional[Boolean]`

Specifies whether a smart card is required to logon. This parameter sets the SmartCardLoginRequired property for a user object. This parameter also sets the ADS_UF_SMARTCARD_REQUIRED flag of the Active Directory User Account Control attribute.

##### `dsc_state`

Data type: `Optional[String]`

Specifies the user's or Organizational Unit's state or province (ldapDisplayName 'st')

##### `dsc_streetaddress`

Data type: `Optional[String]`

Specifies the user's street address (ldapDisplayName 'streetAddress')

##### `dsc_surname`

Data type: `Optional[String]`

Specifies the user's last name or surname (ldapDisplayName 'sn')

##### `dsc_trustedfordelegation`

Data type: `Optional[Boolean]`

Specifies whether an account is trusted for Kerberos delegation (default $false)

##### `dsc_userprincipalname`

Data type: `Optional[String]`

Specifies the UPN assigned to the user account (ldapDisplayName 'userPrincipalName')

#### Parameters

The following parameters are available in the `dsc_xaduser` type.

* [`dsc_domainadministratorcredential`](#dsc_domainadministratorcredential)
* [`dsc_domainname`](#dsc_domainname)
* [`dsc_password`](#dsc_password)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_username`](#dsc_username)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_domainadministratorcredential"></a>`dsc_domainadministratorcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Specifies the user account credentials to use to perform this task

##### <a name="dsc_domainname"></a>`dsc_domainname`

namevar

Data type: `String`

Name of the domain where the user account is located (only used if password is managed)

##### <a name="dsc_password"></a>`dsc_password`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Specifies a new password value for the account

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_username"></a>`dsc_username`

namevar

Data type: `String`

Specifies the Security Account Manager (SAM) account name of the user (ldapDisplayName 'sAMAccountName')

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xwaitforaddomain"></a>`dsc_xwaitforaddomain`

The DSC xWaitForADDomain resource type.
Automatically generated from version 3.0.0.0

#### Properties

The following properties are available in the `dsc_xwaitforaddomain` type.

##### `dsc_rebootretrycount`

Data type: `Optional[Integer[0, 4294967295]]`

The number of times to reboot after failing and then restart retrying.

##### `dsc_retrycount`

Data type: `Optional[Integer[0, 4294967295]]`

The number of retries before failing.

##### `dsc_retryintervalsec`

Data type: `Optional[Integer[0, 18446744073709551615]]`

The interval in seconds between retry attempts.

#### Parameters

The following parameters are available in the `dsc_xwaitforaddomain` type.

* [`dsc_domainname`](#dsc_domainname)
* [`dsc_domainusercredential`](#dsc_domainusercredential)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_domainname"></a>`dsc_domainname`

namevar

Data type: `String`

The name of the AD Domain to wait for.

##### <a name="dsc_domainusercredential"></a>`dsc_domainusercredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

The user account credentials to use to perform this task.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

